######################## BEGIN LICENSE BLOCK ########################
# The Original Code is mozilla.org code.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Mark Pilgrim - port to Python
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301  USA
######################### END LICENSE BLOCK #########################

from .enums import ProbingState, MachineState
from .mbcharsetprober import MultiByteCharSetProber
from .codingstatemachine import CodingStateMachine
from .chardistribution import EUCJPDistributionAnalysis
from .jpcntx import EUCJPContextAnalysis
from .mbcssm import EUCJP_SM_MODEL


class EUCJPProber(MultiByteCharSetProber):
    # 初始化EUCJPProber类
    def __init__(self):
        super(EUCJPProber, self).__init__()
        # 初始化编码状态机
        self.coding_sm = CodingStateMachine(EUCJP_SM_MODEL)
        # 初始化分布分析器
        self.distribution_analyzer = EUCJPDistributionAnalysis()
        # 初始化上下文分析器
        self.context_analyzer = EUCJPContextAnalysis()
        # 重置
        self.reset()

    # 重置
    def reset(self):
        super(EUCJPProber, self).reset()
        self.context_analyzer.reset()

    # 获取字符集名称
    @property
    def charset_name(self):
        return "EUC-JP"

    # 获取语言
    @property
    def language(self):
        return "Japanese"

    # 输入字节流
    def feed(self, byte_str):
        for i in range(len(byte_str)):
            # PY3K: byte_str is a byte array, so byte_str[i] is an int, not a byte
            # 获取下一个状态
            coding_state = self.coding_sm.next_state(byte_str[i])
            # 如果状态为错误
            if coding_state == MachineState.ERROR:
                self.logger.debug('%s %s prober hit error at byte %s',
                                  self.charset_name, self.language, i)
                # 设置状态为不是该字符集
                self._state = ProbingState.NOT_ME
                break
            # 如果状态为确定
            elif coding_state == MachineState.ITS_ME:
                # 设置状态为确定
                self._state = ProbingState.FOUND_IT
                break
            # 如果状态为开始
            elif coding_state == MachineState.START:
                # 获取当前字符长度
                char_len = self.coding_sm.get_current_charlen()
                # 如果是第一个字符
                if i == 0:
                    # 更新最后一个字符
                    self._last_char[1] = byte_str[0]
                    # 输入最后一个字符和当前字符长度到上下文分析器
                    self.context_analyzer.feed(self._last_char, char_len)
                    # 输入最后一个字符和当前字符长度到分布分析器
                    self.distribution_analyzer.feed(self._last_char, char_len)
                else:
                    # 输入前一个字符和当前字符到上下文分析器
                    self.context_analyzer.feed(byte_str[i - 1:i + 1],
                                                char_len)
                    # 输入前一个字符和当前字符到分布分析器
                    self.distribution_analyzer.feed(byte_str[i - 1:i + 1],
                                                     char_len)

        # 更新最后一个字符
        self._last_char[0] = byte_str[-1]

        # 如果状态为检测中
        if self.state == ProbingState.DETECTING:
            # 如果上下文分析器有足够的数据，并且置信度大于阈值
            if (self.context_analyzer.got_enough_data() and
               (self.get_confidence() > self.SHORTCUT_THRESHOLD)):
                # 设置状态为确定
                self._state = ProbingState.FOUND_IT

        # 返回状态
        return self.state

    # 获取置信度
    def get_confidence(self):
        # 获取上下文分析器的置信度
        context_conf = self.context_analyzer.get_confidence()
        # 获取分布分析器的置信度
        distrib_conf = self.distribution_analyzer.get_confidence()
        # 返回最大置信度
        return max(context_conf, distrib_conf)
